<?php

namespace Drupal\require_on_publish\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

/**
 * Validates the RequireOnPublish constraint.
 */
class RequireOnPublishValidator extends ConstraintValidator {

  /**
   * {@inheritdoc}
   */
  public function validate($field, Constraint $constraint) {
    $node = $field->getEntity();

    if ($node->isPublished() && $field->isEmpty()) {
      $label = $field->getFieldDefinition()->getLabel();
      $this->context->addViolation($constraint->message, ['%field_label' => $label]);
    }
  }

}
